diff --git a/src/Makefile.global.in b/src/Makefile.global.in
index 3c473c6..02d75f8 100644
--- a/src/Makefile.global.in
+++ b/src/Makefile.global.in
@@ -306,8 +306,10 @@ libpq_srcdir = $(top_srcdir)/src/interfaces/libpq
 libpq_builddir = $(top_builddir)/src/interfaces/libpq
 endif
 
+# This is for use for libraries linking to libpq.  Because libpqport
+# isn't created with the same link flags as libpq, it can't be used.
 libpq = -L$(libpq_builddir) -lpq
-
+  
 # If doing static linking, shared library dependency can't be
 # used so we specify pthread libs for every usage of libpq
 ifeq ($(enable_shared), no)
@@ -320,6 +322,19 @@ libpq += $(PTHREAD_LIBS)
 endif
 endif
 
+# Force clients to pull symbols from the non-shared library libpgport 
+# rather than pulling some libpgport symbols from libpq just because 
+# libpq uses those functions too.  This makes applications less 
+# dependent on changes in libpq's usage of pgport.  To do this we link to
+# pgport before libpq.  This does cause duplicate -lpgport's to appear
+# on client link lines.
+ifdef PGXS
+libpq_pgport = -L$(libdir) -lpgport $(libpq)
+else
+libpq_pgport = -L$(top_builddir)/src/port -lpgport $(libpq)
+endif
+
+
 submake-libpq:
 	$(MAKE) -C $(libpq_builddir) all
 
@@ -384,9 +399,10 @@ override LDFLAGS := -L$(top_builddir)/src/port $(LDFLAGS)
 endif
 endif
 
-# to make ws2_32.lib the last library
+# to make ws2_32.lib the last library, and always link with shfolder,
+# so SHGetFolderName isn't picked up from shell32.dll
 ifeq ($(PORTNAME),win32)
-LIBS += -lws2_32
+LIBS += -lws2_32 -lshfolder
 endif
 
 # Not really standard libc functions, used by the backend.
diff --git a/src/backend/access/common/tupdesc.c b/src/backend/access/common/tupdesc.c
index 1fbedde..082a126 100644
--- a/src/backend/access/common/tupdesc.c
+++ b/src/backend/access/common/tupdesc.c
@@ -290,10 +290,15 @@ equalTupleDescs(TupleDesc tupdesc1, TupleDesc tupdesc2)
 
 		/*
 		 * We do not need to check every single field here: we can
-		 * disregard attrelid, attnum (it was used to place the row in the
-		 * attrs array) and everything derived from the column datatype.
-		 * Also, attcacheoff must NOT be checked since it's possibly not
-		 * set in both copies.
+		 * disregard attrelid and attnum (which were used to place the row
+		 * in the attrs array in the first place).  It might look like we
+		 * could dispense with checking attlen/attbyval/attalign, since these
+		 * are derived from atttypid; but in the case of dropped columns
+		 * we must check them (since atttypid will be zero for all dropped
+		 * columns) and in general it seems safer to check them always.
+		 *
+		 * attcacheoff must NOT be checked since it's possibly not set
+		 * in both copies.
 		 */
 		if (strcmp(NameStr(attr1->attname), NameStr(attr2->attname)) != 0)
 			return false;
@@ -301,12 +306,18 @@ equalTupleDescs(TupleDesc tupdesc1, TupleDesc tupdesc2)
 			return false;
 		if (attr1->attstattarget != attr2->attstattarget)
 			return false;
+		if (attr1->attlen != attr2->attlen)
+			return false;
 		if (attr1->attndims != attr2->attndims)
 			return false;
 		if (attr1->atttypmod != attr2->atttypmod)
 			return false;
+		if (attr1->attbyval != attr2->attbyval)
+			return false;
 		if (attr1->attstorage != attr2->attstorage)
 			return false;
+		if (attr1->attalign != attr2->attalign)
+			return false;
 		if (attr1->attnotnull != attr2->attnotnull)
 			return false;
 		if (attr1->atthasdef != attr2->atthasdef)
diff --git a/src/backend/access/rtree/rtree.c b/src/backend/access/rtree/rtree.c
index 5ae35be..c93acab 100644
--- a/src/backend/access/rtree/rtree.c
+++ b/src/backend/access/rtree/rtree.c
@@ -595,6 +595,8 @@ rtdosplit(Relation r,
 	rtup = (IndexTuple) index_formtuple(tupDesc,
 										&(v.spl_rdatum), isnull);
 	pfree(isnull);
+	pfree(DatumGetPointer(v.spl_ldatum));
+	pfree(DatumGetPointer(v.spl_rdatum));
 
 	/* set pointers to new child pages in the internal index tuples */
 	ItemPointerSet(&(ltup->t_tid), lbknum, 1);
diff --git a/src/backend/catalog/pg_aggregate.c b/src/backend/catalog/pg_aggregate.c
index 79cb8dc..40b59c4 100644
--- a/src/backend/catalog/pg_aggregate.c
+++ b/src/backend/catalog/pg_aggregate.c
@@ -22,10 +22,13 @@
 #include "catalog/pg_aggregate.h"
 #include "catalog/pg_language.h"
 #include "catalog/pg_proc.h"
+#include "miscadmin.h"
 #include "optimizer/cost.h"
 #include "parser/parse_coerce.h"
 #include "parser/parse_func.h"
+#include "utils/acl.h"
 #include "utils/builtins.h"
+#include "utils/lsyscache.h"
 #include "utils/syscache.h"
 
 
@@ -262,6 +265,7 @@ lookup_agg_function(List *fnName,
 	bool		retset;
 	Oid		   *true_oid_array;
 	FuncDetailCode fdresult;
+	AclResult	aclresult;
 
 	/*
 	 * func_get_detail looks up the function in the catalogs, does
@@ -326,5 +330,10 @@ lookup_agg_function(List *fnName,
 				 errmsg("function %s requires run-time type coercion",
 				 func_signature_string(fnName, nargs, true_oid_array))));
 
+	/* Check aggregate creator has permission to call the function */
+	aclresult = pg_proc_aclcheck(fnOid, GetUserId(), ACL_EXECUTE);
+	if (aclresult != ACLCHECK_OK)
+		aclcheck_error(aclresult, ACL_KIND_PROC, get_func_name(fnOid));
+
 	return fnOid;
 }
diff --git a/src/backend/catalog/pg_proc.c b/src/backend/catalog/pg_proc.c
index 4adb4b6..44c0338 100644
--- a/src/backend/catalog/pg_proc.c
+++ b/src/backend/catalog/pg_proc.c
@@ -72,6 +72,8 @@ ProcedureCreate(const char *procedureName,
 				const char *parameterNames[])
 {
 	int			i;
+	bool		genericParam = false;
+	bool		internalParam = false;
 	Relation	rel;
 	HeapTuple	tup;
 	HeapTuple	oldtup;
@@ -102,29 +104,36 @@ ProcedureCreate(const char *procedureName,
 
 	/*
 	 * Do not allow return type ANYARRAY or ANYELEMENT unless at least one
-	 * argument is also ANYARRAY or ANYELEMENT
+	 * input argument is ANYARRAY or ANYELEMENT.  Also, do not allow
+	 * return type INTERNAL unless at least one input argument is INTERNAL.
 	 */
-	if (returnType == ANYARRAYOID || returnType == ANYELEMENTOID)
+	for (i = 0; i < parameterCount; i++)
 	{
-		bool		genericParam = false;
-
-		for (i = 0; i < parameterCount; i++)
+		switch (parameterTypes[i])
 		{
-			if (parameterTypes[i] == ANYARRAYOID ||
-				parameterTypes[i] == ANYELEMENTOID)
-			{
+			case ANYARRAYOID:
+			case ANYELEMENTOID:
 				genericParam = true;
 				break;
-			}
+			case INTERNALOID:
+				internalParam = true;
+				break;
 		}
-
-		if (!genericParam)
-			ereport(ERROR,
-					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
-					 errmsg("cannot determine result data type"),
-					 errdetail("A function returning \"anyarray\" or \"anyelement\" must have at least one argument of either type.")));
 	}
 
+	if ((returnType == ANYARRAYOID || returnType == ANYELEMENTOID)
+		&& !genericParam)
+		ereport(ERROR,
+				(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+				 errmsg("cannot determine result data type"),
+				 errdetail("A function returning \"anyarray\" or \"anyelement\" must have at least one argument of either type.")));
+
+	if (returnType == INTERNALOID && !internalParam)
+		ereport(ERROR,
+				(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+				 errmsg("unsafe use of INTERNAL pseudo-type"),
+				 errdetail("A function returning \"internal\" must have at least one \"internal\" argument.")));
+
 	/* Make sure we have a zero-padded param type array */
 	MemSet(typev, 0, FUNC_MAX_ARGS * sizeof(Oid));
 	if (parameterCount > 0)
diff --git a/src/backend/commands/proclang.c b/src/backend/commands/proclang.c
index 1269fb3..d672df5 100644
--- a/src/backend/commands/proclang.c
+++ b/src/backend/commands/proclang.c
@@ -246,7 +246,7 @@ RenameLanguage(const char *oldname, const char *newname)
 	HeapTuple	tup;
 	Relation	rel;
 
-	rel = heap_openr(ShadowRelationName, RowExclusiveLock);
+	rel = heap_openr(LanguageRelationName, RowExclusiveLock);
 
 	tup = SearchSysCacheCopy(LANGNAME,
 							 CStringGetDatum(oldname),
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index c6051c0..61b22ed 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -919,16 +919,17 @@ cost_mergejoin(MergePath *path, Query *root)
 	rescanratio = 1.0 + (rescannedtuples / inner_path_rows);
 
 	/*
-	 * A merge join will stop as soon as it exhausts either input stream.
-	 * Estimate fraction of the left and right inputs that will actually
-	 * need to be scanned.	We use only the first (most significant) merge
-	 * clause for this purpose.
+	 * A merge join will stop as soon as it exhausts either input stream
+	 * (unless it's an outer join, in which case the outer side has to be
+	 * scanned all the way anyway).  Estimate fraction of the left and right
+	 * inputs that will actually need to be scanned. We use only the first
+	 * (most significant) merge clause for this purpose.
 	 *
 	 * Since this calculation is somewhat expensive, and will be the same for
 	 * all mergejoin paths associated with the merge clause, we cache the
 	 * results in the RestrictInfo node.
 	 */
-	if (mergeclauses)
+	if (mergeclauses && path->jpath.jointype != JOIN_FULL)
 	{
 		firstclause = (RestrictInfo *) linitial(mergeclauses);
 		if (firstclause->left_mergescansel < 0) /* not computed yet? */
@@ -948,10 +949,14 @@ cost_mergejoin(MergePath *path, Query *root)
 			outerscansel = firstclause->right_mergescansel;
 			innerscansel = firstclause->left_mergescansel;
 		}
+		if (path->jpath.jointype == JOIN_LEFT)
+			outerscansel = 1.0;
+		else if (path->jpath.jointype == JOIN_RIGHT)
+			innerscansel = 1.0;
 	}
 	else
 	{
-		/* cope with clauseless mergejoin */
+		/* cope with clauseless or full mergejoin */
 		outerscansel = innerscansel = 1.0;
 	}
 
diff --git a/src/backend/optimizer/path/orindxpath.c b/src/backend/optimizer/path/orindxpath.c
index 6eb769d..6cc77ef 100644
--- a/src/backend/optimizer/path/orindxpath.c
+++ b/src/backend/optimizer/path/orindxpath.c
@@ -387,10 +387,14 @@ best_or_subclause_index(Query *root,
 
 		/*
 		 * Ignore index if it doesn't match the subclause at all; except
-		 * that if it's a partial index, consider it anyway, since the
-		 * selectivity of the predicate alone might make the index useful.
+		 * that if it's a partial index matching the current OR subclause,
+		 * consider it anyway, since effectively we are using the index
+		 * predicate to match the subclause.  (Note: we exclude partial
+		 * indexes that are predOK; else such a partial index would be
+		 * considered to match *every* OR subclause, generating bogus OR
+		 * plans that are redundant with the basic scan on that index.)
 		 */
-		if (indexclauses == NIL && index->indpred == NIL)
+		if (indexclauses == NIL && (index->indpred == NIL || index->predOK))
 			continue;
 
 		/* Convert clauses to indexquals the executor can handle */
diff --git a/src/backend/optimizer/path/pathkeys.c b/src/backend/optimizer/path/pathkeys.c
index b5598be..f13d3f4 100644
--- a/src/backend/optimizer/path/pathkeys.c
+++ b/src/backend/optimizer/path/pathkeys.c
@@ -858,7 +858,12 @@ build_subquery_pathkeys(Query *root, RelOptInfo *rel, Query *subquery)
  *	  vars they were joined with; furthermore, it doesn't matter what kind
  *	  of join algorithm is actually used.
  *
+ *	  EXCEPTION: in a FULL or RIGHT join, we cannot treat the result as
+ *	  having the outer path's path keys, because null lefthand rows may be
+ *	  inserted at random points.  It must be treated as unsorted.
+ *
  * 'joinrel' is the join relation that paths are being formed for
+ * 'jointype' is the join type (inner, left, full, etc)
  * 'outer_pathkeys' is the list of the current outer path's path keys
  *
  * Returns the list of new path keys.
@@ -866,8 +871,12 @@ build_subquery_pathkeys(Query *root, RelOptInfo *rel, Query *subquery)
 List *
 build_join_pathkeys(Query *root,
 					RelOptInfo *joinrel,
+					JoinType jointype,
 					List *outer_pathkeys)
 {
+	if (jointype == JOIN_FULL || jointype == JOIN_RIGHT)
+		return NIL;
+
 	/*
 	 * This used to be quite a complex bit of code, but now that all
 	 * pathkey sublists start out life canonicalized, we don't have to do
diff --git a/src/backend/optimizer/plan/README b/src/backend/optimizer/plan/README
index d3a5168..a63596f 100644
--- a/src/backend/optimizer/plan/README
+++ b/src/backend/optimizer/plan/README
@@ -6,7 +6,7 @@ From owner-pgsql-hackers@hub.org Fri Feb 13 09:01:19 1998
 Received: from renoir.op.net (root@renoir.op.net [209.152.193.4])
 	by candle.pha.pa.us (8.8.5/8.8.5) with ESMTP id JAA11576
 	for <maillist@candle.pha.pa.us>; Fri, 13 Feb 1998 09:01:17 -0500 (EST)
-Received: from hub.org (hub.org [209.47.148.200]) by renoir.op.net (o1/$Revision: 1.1 $) with ESMTP id IAA09761 for <maillist@candle.pha.pa.us>; Fri, 13 Feb 1998 08:41:22 -0500 (EST)
+Received: from hub.org (hub.org [209.47.148.200]) by renoir.op.net (o1/$Revision$) with ESMTP id IAA09761 for <maillist@candle.pha.pa.us>; Fri, 13 Feb 1998 08:41:22 -0500 (EST)
 Received: from localhost (majordom@localhost) by hub.org (8.8.8/8.7.5) with SMTP id IAA08135; Fri, 13 Feb 1998 08:40:17 -0500 (EST)
 Received: by hub.org (TLB v0.10a (1.23 tibbs 1997/01/09 00:29:32)); Fri, 13 Feb 1998 08:38:42 -0500 (EST)
 Received: (from majordom@localhost) by hub.org (8.8.8/8.7.5) id IAA06646 for pgsql-hackers-outgoing; Fri, 13 Feb 1998 08:38:35 -0500 (EST)
diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
index 3216223..82d3318 100644
--- a/src/backend/optimizer/plan/planner.c
+++ b/src/backend/optimizer/plan/planner.c
@@ -20,6 +20,7 @@
 #include "catalog/pg_operator.h"
 #include "catalog/pg_type.h"
 #include "executor/executor.h"
+#include "executor/nodeAgg.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
 #ifdef OPTIMIZER_DEBUG
@@ -660,10 +661,12 @@ grouping_planner(Query *parse, double tuple_fraction)
 		Path	   *sorted_path;
 		double		dNumGroups = 0;
 		long		numGroups = 0;
-		int			numAggs = 0;
+		AggClauseCounts agg_counts;
 		int			numGroupCols = list_length(parse->groupClause);
 		bool		use_hashed_grouping = false;
 
+		MemSet(&agg_counts, 0, sizeof(AggClauseCounts));
+
 		/* Preprocess targetlist in case we are inside an INSERT/UPDATE. */
 		tlist = preprocess_targetlist(tlist,
 									  parse->commandType,
@@ -752,8 +755,10 @@ grouping_planner(Query *parse, double tuple_fraction)
 		 * the aggregate semantics (eg, producing only one output row).
 		 */
 		if (parse->hasAggs)
-			numAggs = count_agg_clause((Node *) tlist) +
-				count_agg_clause(parse->havingQual);
+		{
+			count_agg_clauses((Node *) tlist, &agg_counts);
+			count_agg_clauses(parse->havingQual, &agg_counts);
+		}
 
 		/*
 		 * Figure out whether we need a sorted result from query_planner.
@@ -990,9 +995,7 @@ grouping_planner(Query *parse, double tuple_fraction)
 			 */
 			if (!enable_hashagg || !hash_safe_grouping(parse))
 				use_hashed_grouping = false;
-			else if (parse->hasAggs &&
-					 (contain_distinct_agg_clause((Node *) tlist) ||
-					  contain_distinct_agg_clause(parse->havingQual)))
+			else if (agg_counts.numDistinctAggs != 0)
 				use_hashed_grouping = false;
 			else
 			{
@@ -1003,13 +1006,15 @@ grouping_planner(Query *parse, double tuple_fraction)
 				 * the need for sorted input is usually a win, the fact
 				 * that the output won't be sorted may be a loss; so we
 				 * need to do an actual cost comparison.
-				 *
-				 * In most cases we have no good way to estimate the size of
-				 * the transition value needed by an aggregate;
-				 * arbitrarily assume it is 100 bytes.	Also set the
-				 * overhead per hashtable entry at 64 bytes.
 				 */
-				int			hashentrysize = cheapest_path_width + 64 + numAggs * 100;
+				Size		hashentrysize;
+
+				/* Estimate per-hash-entry space at tuple width... */
+				hashentrysize = cheapest_path_width;
+				/* plus space for pass-by-ref transition values... */
+				hashentrysize += agg_counts.transitionSpace;
+				/* plus the per-hash-entry overhead */
+				hashentrysize += hash_agg_entry_size(agg_counts.numAggs);
 
 				if (hashentrysize * dNumGroups <= work_mem * 1024L)
 				{
@@ -1030,7 +1035,7 @@ grouping_planner(Query *parse, double tuple_fraction)
 					Path		sorted_p;
 
 					cost_agg(&hashed_p, parse,
-							 AGG_HASHED, numAggs,
+							 AGG_HASHED, agg_counts.numAggs,
 							 numGroupCols, dNumGroups,
 							 cheapest_path->startup_cost,
 							 cheapest_path->total_cost,
@@ -1065,7 +1070,7 @@ grouping_planner(Query *parse, double tuple_fraction)
 					}
 					if (parse->hasAggs)
 						cost_agg(&sorted_p, parse,
-								 AGG_SORTED, numAggs,
+								 AGG_SORTED, agg_counts.numAggs,
 								 numGroupCols, dNumGroups,
 								 sorted_p.startup_cost,
 								 sorted_p.total_cost,
@@ -1202,7 +1207,7 @@ grouping_planner(Query *parse, double tuple_fraction)
 											numGroupCols,
 											groupColIdx,
 											numGroups,
-											numAggs,
+											agg_counts.numAggs,
 											result_plan);
 			/* Hashed aggregation produces randomly-ordered results */
 			current_pathkeys = NIL;
@@ -1244,7 +1249,7 @@ grouping_planner(Query *parse, double tuple_fraction)
 											numGroupCols,
 											groupColIdx,
 											numGroups,
-											numAggs,
+											agg_counts.numAggs,
 											result_plan);
 		}
 		else
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index a655e7b..f2c59f8 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -234,7 +234,32 @@ estimate_rel_size(Relation rel, int32 *attr_widths,
 		case RELKIND_INDEX:
 		case RELKIND_TOASTVALUE:
 			/* it has storage, ok to call the smgr */
-			*pages = curpages = RelationGetNumberOfBlocks(rel);
+			curpages = RelationGetNumberOfBlocks(rel);
+
+			/*
+			 * HACK: if the relation has never yet been vacuumed, use a
+			 * minimum estimate of 10 pages.  This emulates a desirable
+			 * aspect of pre-8.0 behavior, which is that we wouldn't assume
+			 * a newly created relation is really small, which saves us from
+			 * making really bad plans during initial data loading.  (The
+			 * plans are not wrong when they are made, but if they are cached
+			 * and used again after the table has grown a lot, they are bad.)
+			 * It would be better to force replanning if the table size has
+			 * changed a lot since the plan was made ... but we don't
+			 * currently have any infrastructure for redoing cached plans at
+			 * all, so we have to kluge things here instead.
+			 *
+			 * We approximate "never vacuumed" by "has relpages = 0", which
+			 * means this will also fire on genuinely empty relations.  Not
+			 * great, but fortunately that's a seldom-seen case in the real
+			 * world, and it shouldn't degrade the quality of the plan too
+			 * much anyway to err in this direction.
+			 */
+			if (curpages < 10 && rel->rd_rel->relpages == 0)
+				curpages = 10;
+
+			/* report estimated # pages */
+			*pages = curpages;
 			/* quick exit if rel is clearly empty */
 			if (curpages == 0)
 			{
diff --git a/src/backend/port/darwin/system.c b/src/backend/port/darwin/system.c
index cfeaaa0..d05fa17 100644
--- a/src/backend/port/darwin/system.c
+++ b/src/backend/port/darwin/system.c
@@ -34,7 +34,7 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $FreeBSD$
+ * $FreeBSD: src/lib/libc/stdlib/system.c,v 1.6 2000/03/16 02:14:41 jasone Exp $
  */
 
 #if defined(LIBC_SCCS) && !defined(lint)
diff --git a/src/backend/storage/buffer/README b/src/backend/storage/buffer/README
index 2e020d8..5fa316f 100644
--- a/src/backend/storage/buffer/README
+++ b/src/backend/storage/buffer/README
@@ -172,30 +172,22 @@ Buffer replacement strategy
 ---------------------------
 
 The buffer replacement strategy actually used in freelist.c is a version of
-the Adaptive Replacement Cache (ARC) specially tailored for PostgreSQL.
+the Two Queue (2Q) algorithm specially tailored for PostgreSQL.
 
 The algorithm works as follows:
 
-C is the size of the cache in number of pages (a/k/a shared_buffers or
-NBuffers).  ARC uses 2*C Cache Directory Blocks (CDB). A cache directory block
-is always associated with one unique file page.  It may point to one shared
-buffer, or may indicate that the file page is not in a buffer but has been
-accessed recently.
+There are three lists of Cache Directory Blocks (CDBs), T1, T2, and B1.  The
+T1 and T2 lists are the "real" cache entries, linking a file page to a memory
+buffer where the page is currently cached. Consequently T1len+T2len <=
+NBuffers.  B1 is a list of pages that are not currently buffered but recently
+were.  We allocate a total of 1.5*NBuffers CDBs, so the maximum length of B1
+when cache is fully used is NBuffers/2.  The target size of T1 is NBuffers/4.
 
-All CDB entries are managed in 4 LRU lists named T1, T2, B1 and B2. The T1 and
-T2 lists are the "real" cache entries, linking a file page to a memory buffer
-where the page is currently cached. Consequently T1len+T2len <= C. B1 and B2
-are ghost cache directories that extend T1 and T2 so that the strategy
-remembers pages longer. The strategy tries to keep B1len+T1len and B2len+T2len
-both at C. T1len and T2len vary over the runtime depending on the lookup
-pattern and its resulting cache hits. The desired size of T1len is called
-T1target.
-
-Assuming we have a full cache, one of 5 cases happens on a lookup:
+Assuming we have a full cache, one of 4 cases happens on a lookup:
 
 MISS	On a cache miss, depending on T1target and the actual T1len
 	the LRU buffer of either T1 or T2 is evicted. Its CDB is removed
-	from the T list and added as MRU of the corresponding B list.
+	from the T list and added as MRU of B1.
 	The now free buffer is replaced with the requested page
 	and added as MRU of T1.
 
@@ -203,18 +195,12 @@ T1 hit	The T1 CDB is moved to the MRU position of the T2 list.
 
 T2 hit	The T2 CDB is moved to the MRU position of the T2 list.
 
-B1 hit	This means that a buffer that was evicted from the T1
-	list is now requested again, indicating that T1target is
-	too small (otherwise it would still be in T1 and thus in
-	memory). The strategy raises T1target, evicts a buffer
-	depending on T1target and T1len and places the CDB at
-	MRU of T2.
-
-B2 hit	This means the opposite of B1, the T2 list is probably too
-	small. So the strategy lowers T1target, evicts a buffer
-	and places the CDB at MRU of T2.
+B1 hit	This means that a page that was recently evicted from cache
+	is now requested again.  We evict a buffer the same as in
+	the normal cache miss case, but the reloaded page goes to the
+	MRU of T2 rather than T1.
 
-Thus, every page that is found on lookup in any of the four lists
+Thus, every page that is found on lookup in any of the three lists
 ends up as the MRU of the T2 list. The T2 list therefore is the
 "frequency" cache, holding frequently requested pages.
 
@@ -232,8 +218,7 @@ will not promote it from there into the T2 cache during the same transaction.
 
 Another specialty is the change of the strategy during VACUUM.  Lookups during
 VACUUM do not represent application needs, and do not suggest that the page
-will be hit again soon, so it would be wrong to change the cache balance
-T1target due to that or to cause massive cache evictions. Therefore, a page
+will be hit again soon. Therefore, a page
 read in to satisfy vacuum is placed at the LRU position of the T1 list, for
 immediate reuse.  Also, if we happen to get a hit on a CDB entry during
 VACUUM, we do not promote the page above its current position in the list.
diff --git a/src/backend/storage/buffer/buf_init.c b/src/backend/storage/buffer/buf_init.c
index 1420040..6cf3a84 100644
--- a/src/backend/storage/buffer/buf_init.c
+++ b/src/backend/storage/buffer/buf_init.c
@@ -73,7 +73,6 @@ long int	LocalBufferFlushCount;
  *		aborts, it should only unpin the buffers exactly the number of times it
  *		has pinned them, so that it will not blow away buffers of another
  *		backend.
- *
  */
 
 
@@ -120,14 +119,17 @@ InitBufferPool(void)
 		block = BufferBlocks;
 
 		/*
-		 * link the buffers into a single linked list. This will become
-		 * the LIFO list of unused buffers returned by
-		 * StrategyGetBuffer().
+		 * Initialize all the buffer headers.
 		 */
 		for (i = 0; i < NBuffers; block += BLCKSZ, buf++, i++)
 		{
 			Assert(ShmemIsValid((unsigned long) block));
 
+			/*
+			 * The bufNext fields link together all totally-unused buffers.
+			 * Subsequent management of this list is done by
+			 * StrategyGetBuffer().
+			 */
 			buf->bufNext = i + 1;
 
 			CLEAR_BUFFERTAG(buf->tag);
@@ -142,7 +144,7 @@ InitBufferPool(void)
 			buf->wait_backend_id = 0;
 		}
 
-		/* Correct last entry */
+		/* Correct last entry of linked list */
 		BufferDescriptors[NBuffers - 1].bufNext = -1;
 
 		LWLockRelease(BufMgrLock);
@@ -178,7 +180,8 @@ InitBufferPoolAccess(void)
 
 	/*
 	 * Convert shmem offsets into addresses as seen by this process. This
-	 * is just to speed up the BufferGetBlock() macro.
+	 * is just to speed up the BufferGetBlock() macro.  It is OK to do this
+	 * without any lock since the data pointers never change.
 	 */
 	for (i = 0; i < NBuffers; i++)
 		BufferBlockPointers[i] = (Block) MAKE_PTR(BufferDescriptors[i].data);
@@ -201,14 +204,8 @@ BufferShmemSize(void)
 	/* size of data pages */
 	size += NBuffers * MAXALIGN(BLCKSZ);
 
-	/* size of buffer hash table */
-	size += hash_estimate_size(NBuffers * 2, sizeof(BufferLookupEnt));
-
-	/* size of the shared replacement strategy control block */
-	size += MAXALIGN(sizeof(BufferStrategyControl));
-
-	/* size of the ARC directory blocks */
-	size += MAXALIGN(NBuffers * 2 * sizeof(BufferStrategyCDB));
+	/* size of stuff controlled by freelist.c */
+	size += StrategyShmemSize();
 
 	return size;
 }
diff --git a/src/backend/storage/buffer/buf_table.c b/src/backend/storage/buffer/buf_table.c
index 2825768..19d7adf 100644
--- a/src/backend/storage/buffer/buf_table.c
+++ b/src/backend/storage/buffer/buf_table.c
@@ -1,11 +1,11 @@
 /*-------------------------------------------------------------------------
  *
  * buf_table.c
- *	  routines for finding buffers in the buffer pool.
+ *	  routines for mapping BufferTags to buffer indexes.
  *
- * NOTE: these days, what this table actually provides is a mapping from
- * BufferTags to CDB indexes, not directly to buffers.	The function names
- * are thus slight misnomers.
+ * NOTE: this module is called only by freelist.c, and the "buffer IDs"
+ * it deals with are whatever freelist.c needs them to be; they may not be
+ * directly equivalent to Buffer numbers.
  *
  * Note: all routines in this file assume that the BufMgrLock is held
  * by the caller, so no synchronization is needed.
@@ -26,12 +26,29 @@
 #include "storage/bufmgr.h"
 
 
+/* entry for buffer lookup hashtable */
+typedef struct
+{
+	BufferTag	key;			/* Tag of a disk page */
+	int			id;				/* Associated buffer ID */
+} BufferLookupEnt;
+
 static HTAB *SharedBufHash;
 
 
 /*
+ * Estimate space needed for mapping hashtable
+ *		size is the desired hash table size (possibly more than NBuffers)
+ */
+int
+BufTableShmemSize(int size)
+{
+	return hash_estimate_size(size, sizeof(BufferLookupEnt));
+}
+
+/*
  * Initialize shmem hash table for mapping buffers
- *		size is the desired hash table size (2*NBuffers for ARC algorithm)
+ *		size is the desired hash table size (possibly more than NBuffers)
  */
 void
 InitBufTable(int size)
@@ -56,7 +73,7 @@ InitBufTable(int size)
 
 /*
  * BufTableLookup
- *		Lookup the given BufferTag; return CDB index, or -1 if not found
+ *		Lookup the given BufferTag; return buffer ID, or -1 if not found
  */
 int
 BufTableLookup(BufferTag *tagPtr)
@@ -76,10 +93,10 @@ BufTableLookup(BufferTag *tagPtr)
 
 /*
  * BufTableInsert
- *		Insert a hashtable entry for given tag and CDB index
+ *		Insert a hashtable entry for given tag and buffer ID
  */
 void
-BufTableInsert(BufferTag *tagPtr, int cdb_id)
+BufTableInsert(BufferTag *tagPtr, int buf_id)
 {
 	BufferLookupEnt *result;
 	bool		found;
@@ -92,15 +109,15 @@ BufTableInsert(BufferTag *tagPtr, int cdb_id)
 				(errcode(ERRCODE_OUT_OF_MEMORY),
 				 errmsg("out of shared memory")));
 
-	if (found)					/* found something else in the table? */
+	if (found)					/* found something already in the table? */
 		elog(ERROR, "shared buffer hash table corrupted");
 
-	result->id = cdb_id;
+	result->id = buf_id;
 }
 
 /*
  * BufTableDelete
- *		Delete the hashtable entry for given tag
+ *		Delete the hashtable entry for given tag (which must exist)
  */
 void
 BufTableDelete(BufferTag *tagPtr)
